Dirac Video Codec

# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::EncPicture Class Reference

`#include <enc_picture.h>`

Inheritance diagram for dirac::EncPicture:
[legend]
Collaboration diagram for dirac::EncPicture:
[legend]

List of all members.

## Public Member Functions

- EncPicture (const PictureParams &pp)
- virtual ~EncPicture ()
- void InitMEData (const PicturePredParams &predparams, const int num_refs)
    Initialise the motion estimation data arrays.
- MEData & GetMEData ()
    Returns the motion data.
- const MEData & GetMEData () const
    Returns the motion data.
- void DropRef (int rindex)
    Drops a reference from the motion vector data.
- const PicArray & OrigData (CompSort c) const
    Returns a given component of the original data.
- const PicArray & UpOrigData (CompSort cs) const
    Returns a given upconverted component of the original data.
- void SetOrigData ()
    Initialises a copy of the data arrays into the original data.
- const PicArray & DataForME (bool field_coding, CompSort c) const
    Returns a version of the picture data suitable for motion estimation.
- const PicArray & UpDataForME (bool field_coding, CompSort c) const
    Returns a version of the picture data suitable for subpel motion estimation.
- void UpdateStatus (const unsigned int mask)
- void FlipStatus (const unsigned int mask)
- void SetStatus (const int status)
- unsigned int GetStatus () const
- double GetComplexity () const
- void SetComplexity (double c)
- double GetNormComplexity () const
- void SetNormComplexity (double c)
- double GetPredBias () const
- void SetPredBias (double b)

## Private Member Functions

- virtual void ClearData ()
    Delete all the data.
- void AntiAliasFilter (PicArray &out_data, const PicArray &in_data) const
    Filters a (field) picture vertically to reduce aliasing for motion estimation purposes.
- const PicArray & FiltData (CompSort c) const
    Returns an anti-aliased version of the original data.
- const PicArray & UpFiltData (CompSort c) const
    Returns an upconverted anti-aliased version of the original data.
- void SetOrigData (const int c)

## Private Attributes

- PicArray * m_orig_data [3]
- PicArray * m_orig_up_data [3]
- PicArray * m_filt_data [3]
- PicArray * m_filt_up_data [3]
- MEData * m_me_data
- unsigned int m_status
- double m_complexity
- double m_norm_complexity
- double m_pred_bias

## Constructor & Destructor Documentation

dirac::EncPicture::EncPicture | ( | const PictureParams & | pp | ) |

virtual dirac::EncPicture::~EncPicture | ( |  | ) | `[virtual]`

## Member Function Documentation

void dirac::EncPicture::InitMEData | ( | const PicturePredParams & | predparams,
|  | const int | num_refs |
| ) |  |  |

MEData& dirac::EncPicture::GetMEData | ( |  | ) | `[inline]`

References m_me_data.

const MEData& dirac::EncPicture::GetMEData | ( |  | ) | const`[inline]`

References m_me_data.

void dirac::EncPicture::DropRef | ( | int | rindex | ) |

const PicArray& dirac::EncPicture::OrigData | ( | CompSort | c | ) | const`[inline]`

References m_orig_data.

const PicArray& dirac::EncPicture::UpOrigData | ( | CompSort | cs | ) | const

void dirac::EncPicture::SetOrigData | ( |  | ) |

const PicArray& dirac::EncPicture::DataForME | ( | bool | field_coding,
|  | CompSort | c |
| ) |  |  | const

const PicArray& dirac::EncPicture::UpDataForME | ( | bool | field_coding,
|  | CompSort | c |
| ) |  |  | const

void dirac::EncPicture::UpdateStatus | ( | const unsigned int | mask | ) | `[inline]`

References m_status.

void dirac::EncPicture::FlipStatus | ( | const unsigned int | mask | ) | `[inline]`

References m_status.

void dirac::EncPicture::SetStatus | ( | const int | status | ) | `[inline]`

References m_status.

unsigned int dirac::EncPicture::GetStatus | ( |  | ) | const`[inline]`

References m_status.

double dirac::EncPicture::GetComplexity | ( |  | ) | const`[inline]`

References m_complexity.

void dirac::EncPicture::SetComplexity | ( | double | c | ) | `[inline]`

References m_complexity.

double dirac::EncPicture::GetNormComplexity | ( |  | ) | const`[inline]`

References m_norm_complexity.

void dirac::EncPicture::SetNormComplexity | ( | double | c | ) | `[inline]`

References m_norm_complexity.

double dirac::EncPicture::GetPredBias | ( |  | ) | const`[inline]`

References m_pred_bias.

void dirac::EncPicture::SetPredBias | ( | double | b | ) | `[inline]`

References m_pred_bias.

virtual void dirac::EncPicture::ClearData | ( |  | ) | `[private, virtual]`

Reimplemented from dirac::Picture.

void dirac::EncPicture::AntiAliasFilter | ( | PicArray & | out_data,
|  | const PicArray & | in_data |
| ) |  |  | const`[private]`

const PicArray& dirac::EncPicture::FiltData | ( | CompSort | c | ) | const`[private]`

const PicArray& dirac::EncPicture::UpFiltData | ( | CompSort | c | ) | const`[private]`

void dirac::EncPicture::SetOrigData | ( | const int | c | ) | `[private]`

## Member Data Documentation

PicArray* dirac::EncPicture::m_orig_data[3]`[private]`

Referenced by OrigData().

PicArray* dirac::EncPicture::m_orig_up_data[3]`[mutable, private]`

PicArray* dirac::EncPicture::m_filt_data[3]`[mutable, private]`

PicArray* dirac::EncPicture::m_filt_up_data[3]`[mutable, private]`

MEData* dirac::EncPicture::m_me_data`[private]`

Referenced by GetMEData().

unsigned int dirac::EncPicture::m_status`[private]`

Referenced by FlipStatus(), GetStatus(), SetStatus(), and UpdateStatus().

double dirac::EncPicture::m_complexity`[private]`

Referenced by GetComplexity(), and SetComplexity().

double dirac::EncPicture::m_norm_complexity`[private]`

Referenced by GetNormComplexity(), and SetNormComplexity().

double dirac::EncPicture::m_pred_bias`[private]`

Referenced by GetPredBias(), and SetPredBias().

The documentation for this class was generated from the following file:

- enc_picture.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.